(*** Question 1 ***)
let graphe1 = [|
  [1; 3; 5];
  [4];
  [1];
  [2];
  [2];
  [0; 2]
|]


(*** Question 2 ***)
let graphe1_non_oriente = [|
  [1; 3; 5];
  [0; 2; 4];
  [1; 2; 3; 4];
  [0; 2];
  [1; 2];
  [0; 2]
|]



(*** Question 3 ***)
type couleur = Blanc | Gris | Noir
let parcours_profondeur graphe s =
  let n = Array.length graphe in
  let couleur = Array.make n Blanc in

  let rec parcours_profondeur_aux s =
    couleur.(s) <- Gris;
    print_int s; print_string " ";

    let rec traiter_voisins voisins =
      match voisins with
      | [] -> ()
      | voisin :: voisins' -> 
          if couleur.(voisin) = Blanc then parcours_profondeur_aux voisin;
          traiter_voisins voisins'
    in

    traiter_voisins graphe.(s);
    couleur.(s) <- Noir
  in

  parcours_profondeur_aux s;
  print_newline ()

  

(*** Question 4 ***)
let parcours_profondeur_complet graphe =
  let n = Array.length graphe in
  let couleur = Array.make n Blanc in

  let rec parcours_profondeur_aux s =
    couleur.(s) <- Gris;
    print_int s; print_string " ";

    let rec traiter_voisins voisins =
      match voisins with
      | [] -> ()
      | voisin :: voisins' ->
          if couleur.(voisin) = Blanc then parcours_profondeur_aux voisin;
          traiter_voisins voisins'
    in

    traiter_voisins graphe.(s);
    couleur.(s) <- Noir
  in

  for i = 0 to n - 1 do
    if couleur.(i) = Blanc then parcours_profondeur_aux i
  done;
  print_newline ()



(*** Question 5 ***)
let () = 
  parcours_profondeur graphe1 5;                  (* affiche : 5 0 1 4 2 3 *)
  parcours_profondeur graphe1_non_oriente 2;      (* affiche : 2 1 0 3 5 4 *)
  parcours_profondeur_complet graphe1;            (* affiche : 0 1 4 2 3 5 *)
  parcours_profondeur_complet graphe1_non_oriente (* affiche : 0 1 2 3 4 5 *)